﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Couchbase;
using Couchbase.Configuration.Client;
using Couchbase.Core;

namespace CouchbaseTester
{
    class Program
    {
        static void Main(string[] args)
        {
            int lc = 0;
            try {
                if (args.Length != 4) {
                    Console.WriteLine("Usage:\nCouchbaseTester <url> <bucket> <key> <value>");
                    return;
                }
                lc = 1;

                Cluster _cluster =
                    new Cluster(new ClientConfiguration
                    {
                        MaxViewRetries = 5,
                        Servers =
                            new List<Uri> {new Uri(args[0])},
                        BucketConfigs =
                            new Dictionary<string, BucketConfiguration>
                            {
                                {
                                    args[1],
                                    new BucketConfiguration
                                    {
                                        PoolConfiguration =
                                            new PoolConfiguration
                                            {
                                                MaxSize = 30,
                                                MinSize = 5
                                            }
                                    }
                                }
                            }
                    });

                lc = 2;
                IBucket bucket = _cluster.OpenBucket(args[1], "");
                lc = 3;
                Document<string> document = new Document<string>
                {
                    Id = args[2],
                    Content = args[3],
                };
                lc = 4;
                IDocumentResult<string> result1 = bucket.Upsert(document);
                lc = 5;
                IDocumentResult<string> result2 = bucket.GetDocument<string>(args[2]);
                Console.WriteLine("result:");
                Console.WriteLine(result2.Content);
                lc = 6;
            }
            catch (Exception ex) {
                Console.WriteLine("Exception thrown, lc = " + lc);
                Console.WriteLine(ex);
                throw;
            }



        }
    }
}
